Package org.springframework.beans.factory.config

# Class PropertiesFactoryBean

java.lang.Object
org.springframework.core.io.support.PropertiesLoaderSupport
org.springframework.beans.factory.config.PropertiesFactoryBean

All Implemented Interfaces:
  `FactoryBean<Properties>`, `InitializingBean`

public class PropertiesFactoryBean extends org.springframework.core.io.support.PropertiesLoaderSupport implements FactoryBean<Properties>, InitializingBean
Allows for making a properties file from a classpath location available as Properties instance in a bean factory. Can be used to populate any bean property of type Properties via a bean reference.

Supports loading from a properties file and/or setting local properties on this FactoryBean. The created Properties instance will be merged from loaded and local values. If neither a location nor local properties are set, an exception will be thrown on initialization.

Can create a singleton or a new object on each request. Default is a singleton.

Author:
  Juergen Hoeller
See Also:
  - `PropertiesLoaderSupport.setLocation(org.springframework.core.io.Resource)`
  - `PropertiesLoaderSupport.setProperties(java.util.Properties)`
  - `PropertiesLoaderSupport.setLocalOverride(boolean)`
  - `Properties`

## Field Summary

### Fields inherited from class org.springframework.core.io.support.PropertiesLoaderSupport

`localOverride, localProperties, logger`

### Fields inherited from interface org.springframework.beans.factory.FactoryBean

`OBJECT_TYPE_ATTRIBUTE`

## Constructor Summary

Constructors
Constructor
Description
`PropertiesFactoryBean()`

## Method Summary

Modifier and Type
Method
Description
`final void`
`afterPropertiesSet()`
Invoked by the containing `BeanFactory` after it has set all bean properties and satisfied `BeanFactoryAware`, `ApplicationContextAware` etc.
`protected Properties`
`createProperties()`
Template method that subclasses may override to construct the object returned by this factory.
`final Properties`
`getObject()`
Return an instance (possibly shared or independent) of the object managed by this factory.
`Class<Properties>`
`getObjectType()`
Return the type of object that this FactoryBean creates, or `null` if not known in advance.
`final boolean`
`isSingleton()`
Is the object managed by this factory a singleton? That is, will `FactoryBean.getObject()` always return the same object (a reference that can be cached)?
`final void`
`setSingleton(boolean singleton)`
Set whether a shared 'singleton' Properties instance should be created, or rather a new Properties instance on each request.

### Methods inherited from class org.springframework.core.io.support.PropertiesLoaderSupport

`loadProperties, mergeProperties, setFileEncoding, setIgnoreResourceNotFound, setLocalOverride, setLocation, setLocations, setProperties, setPropertiesArray, setPropertiesPersister`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### PropertiesFactoryBean

public PropertiesFactoryBean()

## Method Details

### setSingleton

public final void setSingleton(boolean singleton)
Set whether a shared 'singleton' Properties instance should be created, or rather a new Properties instance on each request.

Default is "true" (a shared singleton).

### isSingleton

public final boolean isSingleton()
Description copied from interface: `FactoryBean`
Is the object managed by this factory a singleton? That is, will `FactoryBean.getObject()` always return the same object (a reference that can be cached)?

NOTE: If a FactoryBean indicates that it holds a singleton object, the object returned from `getObject()` might get cached by the owning BeanFactory. Hence, do not return `true` unless the FactoryBean always exposes the same reference.

The singleton status of the FactoryBean itself will generally be provided by the owning BeanFactory; usually, it has to be defined as singleton there.

NOTE: This method returning `false` does not necessarily indicate that returned objects are independent instances. An implementation of the extended `SmartFactoryBean` interface may explicitly indicate independent instances through its `SmartFactoryBean.isPrototype()` method. Plain `FactoryBean` implementations which do not implement this extended interface are simply assumed to always return independent instances if the `isSingleton()` implementation returns `false`.

The default implementation returns `true`, since a `FactoryBean` typically manages a singleton instance.

Specified by:
  `isSingleton` in interface `FactoryBean<Properties>`
Returns:
  whether the exposed object is a singleton
See Also:
  - `FactoryBean.getObject()`
  - `SmartFactoryBean.isPrototype()`

### afterPropertiesSet

public final void afterPropertiesSet() throws IOException
Description copied from interface: `InitializingBean`
Invoked by the containing `BeanFactory` after it has set all bean properties and satisfied `BeanFactoryAware`, `ApplicationContextAware` etc.

This method allows the bean instance to perform validation of its overall configuration and final initialization when all bean properties have been set.

Specified by:
  `afterPropertiesSet` in interface `InitializingBean`
Throws:
  `IOException`

### getObject

@Nullable public final Properties getObject() throws IOException
Description copied from interface: `FactoryBean`
Return an instance (possibly shared or independent) of the object managed by this factory.

As with a `BeanFactory`, this allows support for both the Singleton and Prototype design patterns.

If this FactoryBean is not fully initialized yet at the time of the call (for example because it is involved in a circular reference), throw a corresponding `FactoryBeanNotInitializedException`.

FactoryBeans are allowed to return `null` objects. The bean factory will consider this as a normal value to be used and will not throw a `FactoryBeanNotInitializedException` in this case. However, FactoryBean implementations are encouraged to throw `FactoryBeanNotInitializedException` themselves, as appropriate.

Specified by:
  `getObject` in interface `FactoryBean<Properties>`
Returns:
  an instance of the bean (can be `null`)
Throws:
  `IOException`
See Also:
  - `FactoryBeanNotInitializedException`

### getObjectType

public Class<Properties> getObjectType()
Description copied from interface: `FactoryBean`
Return the type of object that this FactoryBean creates, or `null` if not known in advance.

This allows one to check for specific types of beans without instantiating objects, for example on autowiring.

In the case of implementations that create a singleton object, this method should try to avoid singleton creation as far as possible; it should rather estimate the type in advance. For prototypes, returning a meaningful type here is advisable too.

This method can be called before this FactoryBean has been fully initialized. It must not rely on state created during initialization; of course, it can still use such state if available.

NOTE: Autowiring will simply ignore FactoryBeans that return `null` here. Therefore, it is highly recommended to implement this method properly, using the current state of the FactoryBean.

Specified by:
  `getObjectType` in interface `FactoryBean<Properties>`
Returns:
  the type of object that this FactoryBean creates, or `null` if not known at the time of the call
See Also:
  - `ListableBeanFactory.getBeansOfType(java.lang.Class<T>)`

### createProperties

protected Properties createProperties() throws IOException
Template method that subclasses may override to construct the object returned by this factory. The default implementation returns the plain merged Properties instance.

Invoked on initialization of this FactoryBean in case of a shared singleton; else, on each `getObject()` call.

Returns:
  the object returned by this factory
Throws:
  `IOException` - if an exception occurred during properties loading
See Also:
  - `PropertiesLoaderSupport.mergeProperties()`